### PROBLEM LINK:

**Author:** Devendra Agarwal

**Tester:** Mugurel Ionut Andreica

**Editorialist:** Lalit Kundu

### DIFFICULTY:

Medium

### PREREQUISITES:

segment tree, lazy propagation, basic maths

### PROBLEM:

Given array A of N size and M operations of type:

- Add v to all elements in a range.
- Multiply v to all elements in a range.
- Reset all items to v in a range.
- Report sum in a range.

### QUICK EXPLANATION:

================

Build a segment tree, where at each node we store \textrm{sum} and variables \textrm{mul} and \textrm{add}, which denotes that the lazy update A_i \leftarrow \textrm{mul}*A_i + \textrm{add} needs to be applied. If required, we update the current node’s sum and variables and propagate the laziness down the tree. Also, an multiplication update v at a node can be summarised as \textrm{mul} \leftarrow \textrm{mul}*v and \textrm{add} \leftarrow \textrm{add}*v and also addition update v at a node can be written as \textrm{add} \leftarrow \textrm{add} + v. Set operation with value v can be written as \textrm{mul} \leftarrow 0 and \textrm{add} \leftarrow v.

### EXPLANATION:

================

#### BASIC SEGMENT TREE STUFF

I assume you know how segment trees and lazy propagation work and the basic concepts behind them like time complexity, nodes, intervals. First, I’ll introduce some terminology I’m going to use.

- Node: It’s one of the nodes in the segment tree, it represents a contiguous interval of the array A.
- Interval of a node is the actual range covered by the node.
- Answer of a node is defined the actual value needed for interval queries. Here, for example, we need sum of values in the range.

Let’s think step by step here.

- For range query problems, try to see if segment tree can be used.
- When does segment tree work? When you can merge two contiguous intervals(
*i.e*nodes) to get answer of merged interval(node) in sublinear time. If complexity of merging is O(K), then complexity for each operation can be worst case O(\textrm{log N}*K). For example, when we talk about range minimum function, we can get minimum value of merged interval by taking minimum of answers of two individual intervals. - Also, for range updates you need to use lazy propagation. What does lazy propagation require to work? It requires that for an interval if we have multiple update operations, we can calculate the answer for that interval without actually updating every element in that interval. For example, if we are trying to find range minimum and range updation query is increase all elements by value v, then our new minimum is sum of existing minimum with v. Here also, we should be able to do this operation in sublinear time because it contributes to the factor of updations and queries.

Let’s see how we use above two points to find here a solution using segment trees. Let’s see the query part first: query is range sum, so merging two intervals is easy, just take the individual sums.

#### THE LAZY PROPAGATION SOLUTION

Now, let’s see how we can handle all updations in such a way that we can find answer for an interval without actually updating the whole interval. We are going to store some data about the updations being done at that interval node and process it to find the answer. What could be this data? How do we find out? We need to observe what kind of operations we are doing. After some certain updations, our A_i could be transformed to something like ((A_i*v_1 + v_2)*v_3 + v_4 + v_5)*v_6 + v_7, where v_1 to v_7 are values of range multiplication or range addition. Now, we can store all these values v_1 to v_7 at our node, but we might have to do O(\textrm{number of queries}) operations at each node, which is not really sublinear. We need to find a compact notation at each node interval.

Now, thing worth noting here is that A_i has been transformed to a linear function of A_i *i.e.* something of form (\textrm{mul}*A_i + \textrm{add}). Now, let’s say I make one more multiplication range update v, what’s the new value of A_i. It’s (\textrm{mul}*v*A_i + \textrm{add}*v). So, we update \textrm{mul} *= v and \textrm{add} *= v at our node. Similarly, if we make a sum update with value v, the new value of A_i is (\textrm{mul}*A_i + \textrm{add} + v), so we update \textrm{add} += v. For setting all elements to v, we can just make one multiplication with 0 and then addition with value v.

So, if this interval is in range L to R, for interval sum, we need \sum_{i=L}^{R}(\textrm{mul}*A_i + \textrm{add}) which we can write as (R-L+1)*\textrm{add} + \textrm{mul}*\sum_{i=L}^{R}A_i. So, we have to store sum of original A_i and R and L(basically size) and two variables \textrm{mul} and \textrm{add} at each node. Now, to make things easier we can just directly store the \textrm{sum} of a node(*i.e.* sum of all elements in that interval) instead of storing sum of original A_i. Then, for each range multiplication update or range addition update, we also update this \textrm{sum} along with the variables \textrm{mul} and \textrm{add}.

Also, as we do we in lazy propagation, we propagate the laziness to the children of a node, if we need to query a children of a lazy node. In this problem, we can individually propagate variables \textrm{mul} and \textrm{add}. So, if at a node \textrm{mul} \ne 1, then we can say that this node is multiplication lazy and if required, we’ll propagate this variable down to the children of this node. Similarly, if at a node \textrm{add} \ne 0, we can say that this node is addition lazy and propagate this laziness down to its children.

### COMPLEXITY:

For building the segment tree we need O(N \textrm{log} N) and each query is O(\textrm{log} N), so total complexity is O(N \textrm{log} N + Q \textrm{log} N).

### PROBLEMS TO SOLVE:

QSET

SPOJ HORRIBLE

FNCS

MSTICK

ANUSAR

FRBSUM

Sherlock and Unique Substrings